<template>
	<div id="recipe" class="content">
		<div class="header">
			<h2>Settings: Recipe</h2>
		</div>
		<div class="container-fluid">
			<div class="row">
				<div class="col-12">
					<div class="wrapper">
						<tabs @change="switchTab($event)">
							<button class="col-3 btn btn-blue mt-2" @click="switchEditMode">
								{{ !isEdit ? "Edit recipe" : "Stop edit" }}
							</button>
							<button
								class="col-3 btn btn-white mt-2 ml-2"
								style="border-color:orange;"
								@click="addRow"
								v-if="isEdit"
							>
								Add material
							</button>
							<button
								class="col-3 btn mt-2 ml-2"
								@click="saveRecipe"
								v-if="isEdit"
							>
								Save recipe
							</button>
							<h3 v-show="isEdit">
								Note: Drag and drop to rearrange recipe's sequence.
							</h3>
							<tab
								v-for="tabItem in tabItems"
								:key="tabItem"
								:name="tabItem"
								:title="tabItem"
							>
								<table class="table table-hover">
									<thead>
										<tr>
											<th :key="`${column.name}`" v-for="column in columns">
												{{ column.title }}
											</th>
											<th></th>
										</tr>
									</thead>
									<template v-if="!isEdit">
										<tr v-for="(item, index) in recipes" :key="index">
											<td scope="row">{{ index + 1 }}</td>
											<td>
												{{ item.material }}
											</td>
											<td>{{ item.weight }} KG</td>
											<td></td>
										</tr>
									</template>
									<template v-else>
										<draggable v-model="recipes" tag="tbody">
											<tr v-for="(item, index) in recipes" :key="index">
												<td scope="row">{{ index + 1 }}</td>
												<td>
													<v-select
														v-model="item.material"
														label="materialId"
														:options="materialsInfo"
													></v-select>
												</td>
												<td>
													<input type="number" v-model="item.weight" /> KG
												</td>
												<td>
													<button
														class="btn btn-red mt-2"
														@click="deleteRow(index)"
													>
														<font-awesome-icon icon="trash" />
													</button>
												</td>
											</tr>
										</draggable>
									</template>
								</table>
							</tab>
						</tabs>
					</div>
				</div>
			</div>
		</div>
	</div>
</template>

<script>
import draggable from "vuedraggable";
import Tabs from "../../components/tab/Tabs";
import Tab from "../../components/tab/Tab";
import RecipeService from "@/services/RecipeService";
import material from "../../assets/data/batch-controller";

var tempRecipes = null;

export default {
	components: {
		Tabs,
		Tab,
		draggable
	},
	data() {
		return {
			tabItems: ["DPNR", "ENR-25", "ENR-50"],
			activeTab: "DPNR",
			dpnr: material.dpnr,
			enr: material.enr,
			isEdit: false,
			columns: [
				{
					title: "Sequence",
					name: "sequence"
				},
				{
					title: "Material",
					name: "material"
				},
				{
					title: "Weight",
					name: "weight"
				}
			],
			recipes: [],
			dragging: false
		};
	},
	computed: {
		/**
		 * Create RecipeService instance.
		 *
		 * @returns {RecipeService}
		 */
		recipeService: function() {
			return new RecipeService();
		},

		materialsInfo: function() {
			if (this.activeTab === "DPNR") {
				return this.dpnr;
			}
			return this.enr;
		}
	},
	mounted() {
		this.showLoadingOverlay();

		// Get recipe data.
		this.recipeService.getRecipeByProduct(this.activeTab).then(response => {
			const { data } = response.data;
			let recipe = data.sort((a, b) => a.sequence - b.sequence);
			this.recipes = recipe;

			this.hideLoadingOverlay();
		});
	},
	methods: {
		/**
		 * Show loading overlay.
		 */
		showLoadingOverlay() {
			this.$JsLoadingOverlay.show({ spinnerIcon: "ball-scale-multiple" });
		},

		/**
		 * Hide loading overlay.
		 */
		hideLoadingOverlay() {
			this.$JsLoadingOverlay.hide();
		},

		/**
		 * Switch tab between DPNR, ENR-25 and ENR-50.
		 * When you switch tab, Vue will request the API to retrieve alert logs data based on the productID.
		 *
		 * 'productId' parameter will be used by AlertService to retrieve alert logs data for specific tab.
		 * AlertService will pass the productId to the API.
		 * Available productID
		 * - DPNR
		 * - ENR-25
		 * - ENR-50
		 */
		switchTab(productId) {
			this.activeTab = productId;
			this.showLoadingOverlay();

			// Get recipe data.
			this.recipeService.getRecipeByProduct(this.activeTab).then(response => {
				const { data } = response.data;
				let recipe = data.sort((a, b) => a.sequence - b.sequence);
				this.recipes = recipe;

				this.hideLoadingOverlay();
			});
		},

		switchEditMode() {
			if (this.isEdit) {
				this.$swal({
					title: `Stop editing?`,
					text: "This will discard unsaved changes",
					showCancelButton: true,
					confirmButtonText: "Confirm",
					cancelButtonText: "Close",
					showCloseButton: true,
					showLoaderOnConfirm: false
				}).then(result => {
					if (result.value) {
						this.recipes = tempRecipes;
						tempRecipes = null;
						this.isEdit = !this.isEdit;
					}
				});
				// do nothing if user cancel
			} else {
				// start editing
				tempRecipes = JSON.parse(JSON.stringify(this.recipes));
				this.isEdit = !this.isEdit;
			}
		},

		addRow() {
			this.recipes.push({
				productId: this.activeTab,
				sequence: this.recipes.length - 1,
				material: "",
				weight: 0
			});
		},

		deleteRow(index) {
			this.recipes.splice(index, 1);
		},

		saveRecipe() {
			this.showLoadingOverlay();
			var items = [];
			this.recipes.forEach((item, index) => {
				items.push({
					material:
						item.material.materialId === undefined
							? item.material
							: item.material.materialId,
					sequence: index + 1,
					weight: Number(item.weight)
				});
			});
			const obj = {
				items: items,
				productId: this.activeTab
			};

			// put recipe data.
			this.recipeService.updateProductRecipe(obj).then(response => {
				if (response.status === 200) {
					this.recipes = JSON.parse(JSON.stringify(items));
					tempRecipes = null;
					this.isEdit = false;
				} else {
					this.$swal({
						title: "Error!",
						text: "Error updating recipe, please try again later.",
						icon: "error",
						confirmButtonText: "OK"
					});
				}
				this.hideLoadingOverlay();
			});
		}
	}
};
</script>

<style lang="scss" scoped>
@import "../../assets/styles/pages/settings/recipe.scss";
@import "../../assets/styles/core/table.scss";
</style>